
/* gcc -O2 -Wall -Werror getkey.c -o getkey */
#ifndef _GNU_SOURCE
# define _GNU_SOURCE
#endif
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
#include <signal.h>
#include <termios.h>
#include <unistd.h>

/* A very simple keygrabber. */

static int can_reset;
static struct termios saved_tp;

void
reset_term(int x)
{
	if (can_reset)
		tcsetattr(0, TCSANOW, &saved_tp);
	_exit(x);
}

int
main(int argc, char **argv)
{
	char    foo;
	char   *list = 0;
	int     alarmlen = 0;
	int     x;
	struct termios new_tp;

	if (argc > 1)
	{
		if (argv[1][0] == '-' && isdigit(argv[1][1]))
		{
			alarmlen = atoi(argv[1] + 1);
			list = argv[2];
		} else
		{
			list = argv[1];
		}
		for (x = 0; list[x]; x++)
			list[x] = toupper(list[x]);
	}
	foo = '\0';
	signal(SIGTERM, reset_term);
	signal(SIGALRM, reset_term);
	alarm(alarmlen);
	if (tcgetattr(0, &saved_tp) < 0)
		return 1;
	can_reset = 1;
	new_tp = saved_tp;
	new_tp.c_iflag = 0;
	new_tp.c_oflag &= ~OPOST;
	new_tp.c_lflag &= ~(ISIG | ICANON);
	if (tcsetattr(0, TCSANOW, &new_tp) < 0)
		return 1;
	for (;;)
	{
		ssize_t rc = read(0, &foo, 1);

		if (rc < 0 && errno == EINTR)
			continue;
		/* Die if we get a control-c or control-d */
		if (rc <= 0 || foo == 3 || foo == 4)
			reset_term(1);
		foo = toupper(foo);
		if ((!list) || strchr(list, foo))
		{
			reset_term(0);
		}
	}
}
